Project Chrono: chrono::ChSphere Class Reference

Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
chrono::ChSphere Class Reference
Chrono::Engine » Geometric objects

## Description

A spherical geometric object for collisions and visualization.

`#include <ChSphere.h>`

Inheritance diagram for chrono::ChSphere:
[legend]
Collaboration diagram for chrono::ChSphere:
[legend]

## Public Member Functions
| ChSphere (double radius)
| ChSphere (const ChSphere &source)
virtual ChSphere * | Clone () const override
| "Virtual" copy constructor (covariant return type).
virtual Type | GetType () const override
| Get the class type as an enum.
double | GetRadius () const
| Get the sphere radius.
virtual double | GetVolume () const override
| Return the volume of this solid.
virtual ChMatrix33 | GetGyration () const override
| Return the gyration matrix for this solid.
virtual ChAABB | GetBoundingBox () const override
| Compute bounding box along the directions of the shape definition frame.
virtual double | GetBoundingSphereRadius () const override
| Return the radius of a bounding sphere for this geometry.
virtual ChVector3d | Baricenter () const override
| Compute center of mass.
virtual ChVector3d | Evaluate (double parU, double parV, double parW) const override
| Evaluate position in box volume.
virtual void | ArchiveOut (ChArchiveOut &archive_out) override
| Method to allow serialization of transient data to archives.
virtual void | ArchiveIn (ChArchiveIn &archive_in) override
| Method to allow de-serialization of transient data from archives.
Public Member Functions inherited from chrono::ChVolume
| ChVolume (const ChVolume &other)
virtual bool | IsClosedU () const
| Return true if the volume is closed (periodic) in the 1st parametric coordinate.
virtual bool | IslosedV () const
| Return true if the volume is closed (periodic) in the 2nd parametric coordinate.
virtual bool | IsClosedW () const
| Return true if the volume is closed (periodic) in the 3rd parametric coordinate.
virtual int | GetManifoldDimension () const override final
| Return dimensionality of this object.
Public Member Functions inherited from chrono::ChGeometry
| ChGeometry (const ChGeometry &other)
void | InflateBoundingBox (ChAABB &bbox) const
| Enlarge the given existing bounding box with the bounding box of this object.
virtual void | Update ()
| Generic update of internal data.

## Static Public Member Functions
static double | GetVolume (double radius)
| Return the volume of this type of solid with given dimensions.
static ChMatrix33 | GetGyration (double radius)
| Return the gyration matrix of this type of solid with given dimensions.
static ChAABB | GetBoundingBox (double radius)
| Return the bounding box of this type of solid with given dimensions.
static double | GetBoundingSphereRadius (double radius)
| Return the radius of a bounding sphere.

## Public Attributes
double | rad
| sphere radius

## Additional Inherited Members
Public Types inherited from chrono::ChGeometry
enum class | Type { NONE , SPHERE , ELLIPSOID , BOX , CYLINDER , TRIANGLE , CAPSULE , CONE , LINE , LINE_ARC , LINE_BEZIER , LINE_CAM , LINE_PATH , LINE_POLY , LINE_SEGMENT , ROUNDED_BOX , ROUNDED_CYLINDER , TRIANGLEMESH , TRIANGLEMESH_CONNECTED , TRIANGLEMESH_SOUP }
| Enumeration of geometric object types.

## Member Function Documentation

## ◆ ArchiveIn()

void chrono::ChSphere::ArchiveIn | ( | ChArchiveIn & | archive_in | ) |
| overridevirtual

Method to allow de-serialization of transient data from archives.

Reimplemented from chrono::ChVolume.

## ◆ ArchiveOut()

void chrono::ChSphere::ArchiveOut | ( | ChArchiveOut & | archive_out | ) |
| overridevirtual

Method to allow serialization of transient data to archives.

Reimplemented from chrono::ChVolume.

## ◆ Baricenter()

virtual ChVector3d chrono::ChSphere::Baricenter | ( |  | ) | const
| inlineoverridevirtual

Compute center of mass.

Reimplemented from chrono::ChGeometry.

## ◆ Clone()

virtual ChSphere * chrono::ChSphere::Clone | ( |  | ) | const
| inlineoverridevirtual

"Virtual" copy constructor (covariant return type).

Implements chrono::ChGeometry.

## ◆ Evaluate()

virtual ChVector3d chrono::ChSphere::Evaluate | ( | double | parU,
|  | double | parV,
|  | double | parW ) const
| inlineoverridevirtual

Evaluate position in box volume.

Reimplemented from chrono::ChVolume.

## ◆ GetBoundingBox()

ChAABB chrono::ChSphere::GetBoundingBox | ( |  | ) | const
| overridevirtual

Compute bounding box along the directions of the shape definition frame.

Reimplemented from chrono::ChGeometry.

## ◆ GetBoundingSphereRadius()

double chrono::ChSphere::GetBoundingSphereRadius | ( |  | ) | const
| overridevirtual

Return the radius of a bounding sphere for this geometry.

Reimplemented from chrono::ChGeometry.

## ◆ GetGyration()

ChMatrix33 chrono::ChSphere::GetGyration | ( |  | ) | const
| overridevirtual

Return the gyration matrix for this solid.

Implements chrono::ChVolume.

## ◆ GetType()

virtual Type chrono::ChSphere::GetType | ( |  | ) | const
| inlineoverridevirtual

Get the class type as an enum.

Reimplemented from chrono::ChGeometry.

## ◆ GetVolume()

double chrono::ChSphere::GetVolume | ( |  | ) | const
| overridevirtual

Return the volume of this solid.

Implements chrono::ChVolume.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono/geometry/ChSphere.h
- D:/W/B/src/chrono-9.0.1/src/chrono/geometry/ChSphere.cpp